---
search:
  exclude: true
---
# inspIRCd SSL Setup 

Before we start, you will need a Debian 10+ VPS (you can get one on digitalocean for example), if you prefer to use your own self hosted server, make sure that port 80 and 443 are correctly port forwarded so that the public ip points to the server and not the router. Once that's done, go and ssh into your debian 10 server. 

You can use DuckDNS to get a free domain name:

![](0.png)
    
    
    [ 192.168.100.1/24 ] [ /dev/pts/13 ] [~/Nextcloud/blog/Conf]
    → ssh root@ech4.duckdns.org
    The authenticity of host 'ech4.duckdns.org (178.128.46.38)' can't be established.
    ECDSA key fingerprint is SHA256:z2HAncB99pfbAUfj9tJY7vlo8EGUzCIUxWBAnjAflcA.
    Are you sure you want to continue connecting (yes/no/[fingerprint])? yes
    Warning: Permanently added 'ech4.duckdns.org,178.128.46.38' (ECDSA) to the list of known hosts.
    Linux debian-s-1vcpu-1gb-lon1-01 4.19.0-10-cloud-amd64 #1 SMP Debian 4.19.132-1 (2020-07-24) x86_64
    
    The programs included with the Debian GNU/Linux system are free software;
    the exact distribution terms for each program are described in the
    individual files in /usr/share/doc/*/copyright.
    
    Debian GNU/Linux comes with ABSOLUTELY NO WARRANTY, to the extent
    permitted by applicable law.
    root@debian-s-1vcpu-1gb-lon1-01:~#
    
    

## **Installation (compiled)**
    
    
    apt update -y && apt upgrade -y
    apt install gnutls-bin pkg-config g++ cmake libssl-dev openssl pkg-config -y
    
    adduser --disabled-password inspircd
    su inspircd
    
    cd
    wget https://github.com/inspircd/inspircd/archive/v3.7.0.tar.gz
    tar xvf v3.7.0.tar.gz
    cd inspircd-3.7.0/
    ./configure --enable-extras ssl_openssl
    
    

![](11.png) ![](12.png) ![](13.png)

next just run the make command stated at the end, and wait for it to build (it takes a while):
    
    
    make -j2 install
    
    

![](10.png)

... wait a long time

![](14.png)

Once it's done goto /inspircd-3.7.0/run/conf and download my config:
    
    
    cd ~/inspircd-3.7.0/run/conf
    
    echo 'welcome to nihilists server!' > inspircd.motd
    echo 'dont be bad!' > inspircd.conf
    wget https:/blog.nowhere.moe/servers/irc/inspircd_ssl.conf -O inspircd.conf
    nano inspircd.conf
    
    
    
    exit #back to the root shell
    cp /home/inspircd/inspircd-3.7.0/run/inspircd.service /etc/systemd/system/inspircd.service
    systemctl enable inspircd
    
    su inspircd
    cd /home/inspircd/inspircd-3.7.0/run/
    ./inspircd start
    
    nestat -lntp
    

![](15.png)

And here we can see that the server is running, now let's try to login:

ssl login failed, very lazy to figure out why it doesn't let me connect, lol. Probably it is either in the irssi connection command (**/connect -ssl irc.ech4.duckdns.org 6667 123456**) or something very easy to overlook in the config file as usual. If you have the solution for this, don't hesitate to send me the solution. Instead i'll just move over to the TOR version which looks a trillion times easier to do.

## **CLI IRC Client (expected)**

Connect: irc.ech4.duckdns.org:6667:
    
    
    apt install irssi -y
    irssi
    
    #/connect IP PORT PASSWORD NICKNAME
    
    /connect -ssl 127.0.0.1 6667 123456 nihilist 
    /disconnect
    
    /connect -ssl 167.172.60.28 6667 123456 nihilist
    /disconnect
    
    /connect -ssl ech4.duckdns.org 6667 123456 nihilist
    
    /LIST
    #this will show you which channels are active
    
    /join #general
    	hello!
    	how are you?
    	bye!
    	/leave
    /join #test
    	ahoy!
    	test?
    	goodbye!
    	/leave
    /disconnect
    

![](4.png) ![](5.png)

For extra details on how to configure your IRC server just look at that example [](https://blog.nowhere.moe/inspircd/inspircd.example.conf)file:
    
    
    cd /usr/share/doc/inspircd/examples/
    gunzip -d inspircd.conf.example.gz
    nano inspircd.conf.example
    	
    	
    

## **GUI IRC Client (expected)**

If you don't like irssi, you can use hexchat (GUI) to connect aswell:
    
    
    apt install hexchat -y
    pacman -S hexchat -y
    
    

![](6.png)

