---
search:
  exclude: true
---
# Pfsense site-to-site VPN 

![](0.png)

In this tutorial we're going to look at how to setup a Site-To-Site VPN using pfsense's OpenVPN implementation. Before you start, make sure you have a similar network graph as shown above, with at least 1 host inside each of the 2 lans to access both pfsense's web interface. You can check out [this](../pf_prox/index.md) tutorial to set it up on proxmox. 

## **Site A (10.0.0.0/16)**

We're going to start on Site A (10.0.0.0/16) simply go on your pfsense's Web Interface: 

![](1.png) ![](2.png) ![](3.png)

Leave the rest as default, then hit 'Save' at the bottom of the page.

![](4.png) ![](5.png)

Next add a WAN rule for openvpn traffic:

![](6.png)

Once that's done we want to add a OpenVPN rule to allow all traffic inside the VPN tunnel:

![](7.png) ![](8.png)

Once that's done, hit 'Apply Changes'

![](9.png)

Now go get the shared key and copy it:

![](10.png)

## **Site B (10.2.0.0/16)**

First thing on Site B is to get to the second pfsense's Web Interface (10.2.0.1/16): 

![](11.png) ![](12.png)

Now for the next part you need to find a way to copy **Site A's shared key, over to our Site B's pfsense web interface.** What i did was basically create a debian10 CT on proxmox (because i know you can easily switch them from one network to another without powering them off) Then pasted the key into **/tmp/randomfile.txt** , then moved it into the second LAN to activate **python3 -m http.server 8080** (which i then accessed from the other windows host in that same lan) to finish the copy paste process. 

![](13.png)

Once that's done, specify the Tunnel Network (10.99.99.0/24) AND the remote IPv4 Network (10.0.0.0/16) 

![](14.png)

And just hit 'Save' at the bottom of the page.

![](15.png) ![](16.png)

And as you can see once you check the OpenVPN status from the client Site (Site B) you see that there are bytes sent and recieved. This means that it worked ! so let's test the connection from 10.2.0.0/16 to 10.99.99.0/24 to 10.0.0.0/16: 

![](17.png)

As you can see we are able to reach both our siteB's LAN and VPN pfsense interfaces, but we still can't reach the other side, that's because we forgot to add a rule to allow the VPN traffic on the SiteB pfsense, so let's add it:

![](18.png)

Just like before we basically want to allow all VPN traffic:

![](19.png)

We also want to allow the OpenVPN traffic:

![](20.png) ![](21.png)

Then hit 'Save' and 'Apply changes', 

## **Testing the connection**

Once you finished that, enable the OVPN interfaces :

![](30.png) ![](31.png) ![](32.png) ![](33.png)

Once you're here you can finally test the connectivity in between hosts, you can just use the **ping** command, but to illustrate the interaction with the VPN we're going to use **traceroute** utility:

![](34.png)

And that's it! we managed to create a Site-To-Site Pfsense VPN connection.

