---
search:
  exclude: true
---
# Windows DNS Server Setup (QEMU) 

## **Initial Requirement**

You will require a working Windows Server 2019 VM, or KVM (QEMU) and a graphical access to it:

![](1.png)

## **Installation**

First things first, add the DNS role (service) from the Server Manager Dashboard:

![](2.png) ![](3.png) ![](4.png) ![](5.png) ![](6.png)

We will configure the static ip address later on.

![](7.png)

Then just keep hitting next at everything and install in the end:

![](8.png)

Once it's done installing, we navigate over to the DNS tool:

![](9.png) ![](10.png)

And here we are at the DNS manager utility. Here we're going to setup a local domain for our windows server. But to do so, we first need to setup a static IP address to our machine. 

![](11.png)

Hit Win+X > Network Connections> Network and Sharing Center > Change Adapter Settings > Ethernet > Properties

![](12.png) ![](13.png)

Here i selected my host machine as the gateway, and i've setup my windows server to a memorable private ip address: .100 in the 192.168.100 private network that i configured within virt-manager as part of my current QEMU setup. 

Now that we're done setting the private ip, we can verify it is working so hit Win+X again:

![](14.png)

Then type ipconfig /all:

![](15.png)

Now that we know our server is at the ip address 192.168.100.100/24 let's face it, noone wants to remember ip addreses we want something easier to remember it with, and therefore, we'll setup a DNS entry (A entry) that will translate the private IP address, into a memorable string. For instance, we'll call this server "coolserver" in our local domain "nowhere.local" And this will give us the resulting domain "coolserver.nowhere.local" 

![](16.png) ![](17.png) ![](18.png)

Important thing to note here, this is going to create a .dns file in the system32/dns folder. if you don't like windows' GUI, you can always go there and edit the .dns file just like you would edit a .txt file. 

## **Creating the A Record**

![](19.png) ![](20.png)

Next we're going to create the A record:

![](21.png) ![](22.png) ![](23.png)

And there we have it! now let's make sure this Windows Server uses the correct DNS by going into the IP settins just like we did earlier on:

![](24.png)

Here we set 127.0.0.1 because this is the loopback address, this points to the server itself. Now let's see if it works from our Powershell Prompt:

![](25.png) ![](26.png)

And as you can see here, we have been able to ping the domain coolserver.nowhere.com that we setup on our local DNS server, and with it, we see that we have been able to guess which ip this domains is referring to. 

